QGIS Application - Bug report #14800
Problem rendering joined field from csv
2016-05-10 02:26 AM - Willy Bueno

Status: Closed
Priority: Normal
Assignee: Matthias Kuhn
Category: Unknown

Affected QGIS version:2.14.2
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 22757

Description

QGIS 2.14 hangs when applying gradient symbology on a joined field. Doing the same symbology on an attribute field has no problem.

This problem does not exist in 2.12. Please find attached sample project.

Associated revisions

Revision 22acf3b1 - 2016-05-11 01:34 AM - Nyall Dawson
Avoid refreshing canvas for every joined feature

Instead of setting the provider's subsetString to fetch joined
features, use a feature request with FilterExpression instead.
(Setting the subsetString results in a canvas refresh.)
Performance should be similar (if expression compilation is
enabled) and this also has the advantage of avoiding provider-

specific behaviour (eg case insensitive matching).

(fix #14800)

Revision 804ac7e5 - 2016-05-16 07:56 AM - Nyall Dawson
Avoid refreshing canvas for every joined feature

Instead of setting the provider's subsetString to fetch joined
features, use a feature request with FilterExpression instead.
(Setting the subsetString results in a canvas refresh.)
Performance should be similar (if expression compilation is
enabled) and this also has the advantage of avoiding provider-

specific behaviour (eg case insensitive matching).

(fix #14800)

(cherry-picked from 22acf3b1a3e7a6afe094ec6dec83776256d2655a)

History

#1 - 2016-05-10 05:18 AM - Nyall Dawson

2025-04-28




- Assignee set to Matthias Kuhn

Matthias - ( assigning you just to draw your attention to this). I've tracked it down and it looks like it was caused by
0f2dfdb19bdiace179a6b19cc1dbc4e4918d3f10 - "Reload data when subsetString changes.". The issue is that

QgsVectorLayerFeaturelterator::FetchJoinInfo::addJoinedAttributesDirect repeatedly calls setSubsetString, and for every feature this results in the

dataChanged() signal being emitted. This signal gets caught by map canvas and forces a redraw. So for every feature a redraw is occurring... ouch! Any

ideas on a fix for this?

#2 - 2016-05-10 04:35 PM - Nyall Dawson
- Status changed from Open to Closed

Fixed in changeset commit:"22acf3b1a3e7ab6afe094ec6dec83776256d2655a".

#3 - 2017-09-22 10:05 AM - Jiirgen Fischer

- Category set to Unknown

Files
RenderCSV.zip 237 KB 2016-05-10 Willy Bueno
2025-04-28 2/2



